<?php

if (!defined('INCLUDED_AMEMBER_CONFIG')) 
    die("Direct access to this location is not allowed");

	
class protect_moodle extends amember_integration_plugin
{
	var $db_error = 0;
	var $debug_sql = 0;

    function get_max($status)
	{ 
        global $db;
        $pn = $this->get_plugin_name();
        $ret = array();
        foreach ($db->get_products_list() as $pr)
		{
            if (($status[$pr['product_id']]>0) && ($v=$pr[$pn.'_access']))
                if (is_array($v))
                    $ret = @array_merge($ret, $v);
                else
                    $ret[] = $v;                    
        }
        $ret = array_unique($ret);
        sort($ret);
        return $ret;
    }
	
    function subscription_updated($member_id, $oldmember, $newmember)
	{
		global $db;

		$moodle_user = $this->moodle_get_user($oldmember['login']);
		if (!$moodle_user) return;
        $pass = md5($newmember['pass']);
        $oldmember = $this->escape_record($oldmember);
        $newmember = $this->escape_record($newmember);
        $this->query($s = "UPDATE [db]user SET
							username='$newmember[login]',
							password='$pass',
							firstname='$newmember[name_f]',
							lastname='$newmember[name_l]',
							email='$newmember[email]',
							address='$newmember[street]',
							city='$newmember[city]',
							country='$newmember[country]'
				           WHERE id = '$moodle_user[id]'");
    }
	
	function subscription_added($member_id, $product_id, $member)
	{
		global $db;
		$moodle_user = $this->moodle_get_user($member['login']);
		
		$pass = md5($member['pass']);
		$member = $this->escape_record($member);
		if ($moodle_user)
		{
			$moodle_user_id = $moodle_user['id'];
			$this->query("UPDATE [db]user SET
							deleted=0,
							username='$member[login]',
							password='$pass',
							email='$member[email]',
							address='$newmember[street]',
							city='$member[city]',
							country='$member[country]',
							timemodified='".time()."'
						  WHERE id = '$moodle_user_id'");
		} else {
			if ($mnet_localhost_id = $this->moodle_get_config('mnet_localhost_id'))
				$mnethostid = "mnethostid = '$mnet_localhost_id',";
			$this->query("INSERT INTO [db]user SET
						auth='amember',
						confirmed=1,
						policyagreed=0,
						deleted=0,
						$mnethostid
						username='$member[login]',		
						password='$pass',
						firstname='$member[name_f]',
						lastname='$member[name_l]',
						email='$member[email]',
						address='$newmember[street]',
						city='$member[city]',
						country='$member[country]',
						lang='en_utf8',
						timemodified='".time()."'");
			$moodle_user_id = mysql_insert_id();
			if (!$moodle_user_id) $moodle_user = $this->moodle_get_user($member['login']);
			if ($moodle_user) $moodle_user_id = $moodle_user['id'];
		}
		$this->moodle_enrole($member, $moodle_user_id);
	}
	
	function subscription_deleted($member_id, $product_id, $member)
	{
		global $db;
		$moodle_user = $this->moodle_get_user($member['login']);
		if (!$moodle_user) return;
		$moodle_user_id = $moodle_user['id'];
		$max = $this->get_max($member['data']['status']);

		$courses = array();
		$pn = $this->get_plugin_name();
		$product = $db->get_product($product_id);
		if (is_array($product[$pn.'_access']))
			$courses = $product[$pn.'_access'];
		else
			$courses[] = $product[$pn.'_access'];
		if (!$courses) return;
		foreach ($courses as $course_id)
			$this->moodle_unassign_student_role($moodle_user_id, $course_id);
	}
	
    function subscription_removed($member_id, $member)
	{
		global $db;
		if (!$this->config['remove_users'])
			return;
		
		$moodle_user = $this->moodle_get_user($member['login']);
		if (!$moodle_user) return;
		$moodle_user_id = $moodle_user['id'];
		$courses = $this->get_max($member['data']['status']);
		foreach ($courses as $course_id)
			$this->moodle_unassign_student_role($moodle_user_id, $course_id);
		if ($this->config['remove_users'] == 2)
			$this->query("DELETE FROM [db]user WHERE id = '$moodle_user_id'");
	}
	
    function subscription_check_uniq_login($login, $email, $pass)
	{
	    global $db;
        $login = $db->escape($login);
        $email = $db->escape($email);
        $pass = $db->escape($pass);
        $res = $this->query_one("SELECT COUNT(*) FROM [db]user 
			WHERE username = '$login'  
            AND (email <> '$email'
            OR password <> MD5('$pass'))");
        return !$res;
    }	
	
    function subscription_rebuild(&$users)
	{
        global $db;
        // check all members from aMember DB
        foreach ($users as $login => $rec)
		{
            $m = $db->users_find_by_string($login, 'login', 1);
            $m = $m[0];
            if ($m['login'] == $login)
                $this->subscription_added($m['member_id'], $rec['product_id'][0], $m);
        }
    }

    function after_logout()
    {
		global $db;
		$moodle_settings = $this->moodle_get_settings();
		$sessioncookie = $this->moodle_get_config('sessioncookie');
		$sessioncookiepath = $this->moodle_get_config('sessioncookiepath');
		if ($sessioncookiepath == '') $sessioncookiepath = '/';
		$session_test_cookiename = 'MoodleSessionTest'.$sessioncookie;
		$session_cookiename = 'MoodleSession'.$sessioncookie;
		
		$session_cookie_value = $_COOKIE[$session_cookiename];
		$session_test_cookie_value = $_COOKIE[$session_test_cookiename];		
		
		$cookiename = 'MOODLEID_'.$sessioncookie;
		setcookie($session_test_cookiename, '', time() - 3600, $sessioncookiepath);
		setcookie($session_cookiename, '', time() - 3600, $sessioncookiepath);
		setcookie($cookiename, '', time() - 3600, $sessioncookiepath);
		setcookie('amember_moodle_cookies_set', '', time() - 3600, '/');
		
		$dbsessions = $this->moodle_get_config('dbsessions');
		if ($session_cookie_value)
		{
			if ($dbsessions)
				$this->query("DELETE FROM [db]sessions2 WHERE sesskey = '".$db->escape($session_cookie_value)."'");
			else
				@unlink($moodle_settings['dataroot']."/sessions/sess_".$session_cookie_value);
		}
    }

	function check_logged_in($get_session=0)
    {
		global $db;
		$moodle_settings = $this->moodle_get_settings();
		$sessioncookie = $this->moodle_get_config('sessioncookie');
		$session_cookiename = 'MoodleSession'.$sessioncookie;
		$session_test_cookiename = 'MoodleSessionTest'.$sessioncookie;
		
		$session_cookie_value = $_COOKIE[$session_cookiename];
		$session_test_cookie_value = $_COOKIE[$session_test_cookiename];
		
		if (!$session_cookie_value)
			return array('', '');
		
		$dbsessions = $this->moodle_get_config('dbsessions');
		
		if ($dbsessions)
			$session_data = urldecode($this->query_one("SELECT sessdata FROM [db]sessions2 WHERE sesskey = '".$db->escape($session_cookie_value)."'"));
		else
			$session_data = implode('',@file($moodle_settings['dataroot']."/sessions/sess_".$session_cookie_value));

		if (!$session_data)
			return array('', '');
		else
			$session_exist = 1;
			
		$session_data = $this->moodle_parse_session_data($session_data);
		
		if ($get_session==1) return array($session_exist, $session_data);
		
		if (!$session_data['username'] || $session_data['id'] == 0)
			return array('', '');
		
		$res = $db->query("SELECT * FROM {$db->config['prefix']}members WHERE login = '".$db->escape($session_data['username'])."'");
		if (!$res)
			return array('', '');
		$member = mysql_fetch_assoc($res);
		if (md5($member['pass']) == $session_data['password']) // password match
			return array($member['login'], $member['pass']);
		else
			return array('', '');
	}
	
    function after_login($member)
    {
		global $db;
		if ($_COOKIE['amember_moodle_cookies_set']) return;
		
		$moodle_settings = $this->moodle_get_settings();	
		$sessioncookie = $this->moodle_get_config('sessioncookie');
		$sessioncookiepath = $this->moodle_get_config('sessioncookiepath');
		if ($sessioncookiepath == '') $sessioncookiepath = '/';		
		$sessiontimeout = intval($this->moodle_get_config('sessiontimeout'));		
		if ($sessiontimeout) $sessiontimeout = time() + $sessiontimeout;
		
		$session_test_cookiename = 'MoodleSessionTest'.$sessioncookie;
		$session_cookiename = 'MoodleSession'.$sessioncookie;
		$cookiename = 'MOODLEID_'.$sessioncookie;
		
		// get old session values
		$session_cookie_value = $_COOKIE[$session_cookiename];
		$session_test_cookie_value = $_COOKIE[$session_test_cookiename];
		
		// set sesion values using old or create new
		$session_test = $session_test_cookie_value ? $session_test_cookie_value : $this->moodle_random_string(10);
		$sesskey = $this->moodle_random_string(10);
		$session_id = $session_cookie_value ? $session_cookie_value : md5(uniqid(rand(), true));
		
		$moodle_user = $this->moodle_get_user($member['login']);
		$session_text = $this->moodle_get_session_text($session_test, $sesskey, $moodle_user);
		$dbsessions = $this->moodle_get_config('dbsessions');
		
		if ($dbsessions)
		{
			$expiry = date('Y-m-d H:i:s',$sessiontimeout);
			$created = date('Y-m-d H:i:s',time());
			$modified = date('Y-m-d H:i:s',time()+1);
			$sessdata = urlencode($session_text);
			$this->query("REPLACE INTO [db]sessions2 SET sesskey = '$session_id',
							expiry = '$expiry', created = '$created',  modified = '$modified', sessdata = '".$db->escape($sessdata)."'");
		} else {
			$this->moodle_fwrite($moodle_settings['dataroot']."/sessions/sess_".$session_id, $session_text);
		}
		$sessiontimeout=0;
		setcookie($session_test_cookiename, $session_test, $sessiontimeout, $sessioncookiepath);
		setcookie($session_cookiename, $session_id, $sessiontimeout, $sessioncookiepath);
		setcookie($cookiename, '', time() - 3600, $sessioncookiepath);
		setcookie($cookiename, $this->moodle_rc4encrypt($member['login']), time()+3600, $sessioncookiepath);
		setcookie('amember_moodle_cookies_set', '1', 0, '/');
	}

	function moodle_get_session_text($session_test, $sesskey, $moodle_user)
	{
		$moodle_settings = $this->moodle_get_settings();
		$moodle_user_id = $moodle_user['id'];
		$session_session = array('session_test' => $session_test,
					'cal_course_referer' => 1,
					'cal_show_global' => true,
					'cal_show_groups' => true,
					'cal_show_course' => true,
					'cal_show_user' => true,
					'cal_users_shown' => "$moodle_user_id",
					'logincount' => 0
		);
		$session_text = 'SESSION|O:6:"object"'.substr(serialize($session_session),1);
		
		$moodle_courses_contexts = $this->moodle_get_courses_contextid($moodle_user_id);
		$student_capabilities = $this->moodle_get_student_capabilities();
		foreach ($moodle_courses_contexts as $context_id)
		{
			$courses_capabilities[intval($context_id)] = $student_capabilities;
		}
		$courses_capabilities[1] = $this->moodle_get_site_capabilities();
		$session_user = array('id' => $moodle_user_id,
		            'auth' => $moodle_user['auth'],
		            'confirmed' => $moodle_user['confirmed'],
		            'policyagreed' => $moodle_user['policyagreed'],
		            'deleted' => $moodle_user['deleted'],
		            'username' => $moodle_user['username'],
		            'password' => $moodle_user['password'],
		            'idnumber' => $moodle_user['idnumber'],
		            'firstname' => $moodle_user['firstname'],
		            'lastname' => $moodle_user['lastname'],
		            'email' => $moodle_user['email'],
		            'emailstop' => $moodle_user['emailstop'],
					'icq' => $moodle_user['icq'],
					'skype' => $moodle_user['skype'],
					'yahoo' => $moodle_user['yahoo'],
					'aim' => $moodle_user['aim'],
					'msn' => $moodle_user['msn'],
					'phone1' => $moodle_user['phone1'],
					'phone2' => $moodle_user['phone2'],
					'institution' => $moodle_user['institution'],
					'department' => $moodle_user['department'],
					'address' => $moodle_user['address'],
					'city' => $moodle_user['city'],
					'country' => $moodle_user['country'],
					'lang' => $moodle_user['lang'],
					'theme' => $moodle_user['theme'],
					'timezone' => $moodle_user['timezone'],
					'firstaccess' => $moodle_user['firstaccess'],
		            'lastaccess' => time()+1,
		            'lastlogin' => time(),
		            'currentlogin' => time(),
					'lastip' => $_SERVER['REMOTE_ADDR'],
					'secret' => $moodle_user['secret'],
					'picture' => $moodle_user['picture'],
					'url' => $moodle_user['url'],
					'description' => $moodle_user['description'],
					'mailformat' => $moodle_user['mailformat'],
					'maildigest' => $moodle_user['maildigest'],
					'maildisplay' => $moodle_user['maildisplay'],
					'htmleditor' => $moodle_user['htmleditor'],
					'ajax' => $moodle_user['ajax'],
					'autosubscribe' => $moodle_user['autosubscribe'],
					'trackforums' => $moodle_user['trackforums'],
					'timemodified' => $moodle_user['timemodified'],
					'trustbitmask' => $moodle_user['trustbitmask'],
		            'loggedin' => true,
					'site' => $moodle_settings['wwwroot'],
		            'sesskey' => $sesskey,
		            'sessionIP' => md5($this->moodle_getremoteaddr()),
					'capabilities' => $courses_capabilities
		);
		$session_text .= 'USER|O:8:"stdClass"'.substr(serialize($session_user),1);
		return $session_text;
	}
	
	function moodle_get_student_capabilities()
	{
		$capabilities = array();
		$res = $this->query("SELECT * FROM [db]role_capabilities WHERE roleid=5 AND contextid=1 ORDER BY capability");
		while ($capability = mysql_fetch_assoc($res))
		{
			$capabilities[$capability['capability']] = $capability['permission'];
		}
		return $capabilities;
	}
	
	function moodle_get_site_capabilities()
	{
		$notloggedinroleid = $this->moodle_get_config('notloggedinroleid');
		$capabilities = array();
		$res = $this->query($s = "SELECT * FROM [db]role_capabilities WHERE roleid=$notloggedinroleid AND contextid=1 ORDER BY capability");
		while ($capability = mysql_fetch_assoc($res))
		{
			if ($capability['capability'] != 'moodle/course:view' && $capability['capability'] != 'moodle/legacy:guest')
				$capabilities[$capability['capability']] = $capability['permission'];
		}
		return $capabilities;		
	}
	
	function moodle_parse_session_data($session_data)
	{
		if (!$session_data)
			return array();
		$pos_session = strpos($session_data, "SESSION|");
		$pos_user = strpos($session_data, "USER|");
		$session_session = array();
		$session_user = array();
		if ($pos_session !== false)
		{
			if ($pos_session == 0)
			{
				if ($pos_user !== false)
				{
					$session_user = unserialize("a".substr($session_data,strpos($session_data,"stdClass",$pos_user)+9));
					$session_session = unserialize("a".substr($session_data,$sb=strpos($session_data,"object",$pos_session)+7,$pos_user-$sb));
				} else {
					$session_session = unserialize("a".substr($session_data,$sb=strpos($session_data,"object",$pos_session)+7));
				}
			} else {
				if ($pos_user !== false)
					$session_user = unserialize("a".substr($session_data,$sb=strpos($session_data,"stdClass",$pos_user)+9,$pos_session-$sb));
				$session_session = unserialize("a".substr($session_data,strpos($session_data,"object",$pos_session)+7));
			}
		} else {
			if ($pos_user !== false)
				$session_user = unserialize("a".substr($session_data,strpos($session_data,"stdClass",$pos_user)+9));
		}
		return $session_user;
	}
	
	function moodle_add_log($userid, $course, $module, $action, $url)
	{
		global $db;
		$url = $db->escape($url);
		$this->query("INSERT INTO [db]log SET
					time='".time()."',
					userid='$userid',
					ip='".$_SERVER['REMOTE_ADDR']."',
					course='$course',
					module='$module',
					cmid='0',
					action='$action',
					url='$url',
					info='$userid'");
	}
	
	function moodle_get_user_courses($moodle_user_id)
	{
		global $db;
		if (!$moodle_user_id) return;
		$courses=array();
		$res = $this->query("SELECT t2.instanceid FROM [db]role_assignments AS t1 LEFT JOIN [db]context AS t2 ON t1.contextid = t2.id WHERE t1.userid = '$moodle_user_id' AND t2.contextlevel='50'");
		while ($course = mysql_fetch_assoc($res))
			$courses[] = $course['instanceid'];
		$courses = array_unique($courses);
		return $courses;
	}
	
	function moodle_get_courses_contextid($moodle_user_id)
	{
		global $db;
		if (!$moodle_user_id) return;
		$contexts=array();
		$res = $this->query("SELECT t2.id FROM [db]role_assignments AS t1 LEFT JOIN [db]context AS t2 ON t1.contextid = t2.id WHERE t1.userid = '$moodle_user_id' AND t2.contextlevel='50'");
		while ($context = mysql_fetch_assoc($res))
			$contexts[] = $context['id'];
		$contexts = array_unique($contexts);
		return $contexts;		
	}
	
	function moodle_get_course_roleid($course)
	{
		if ($course['defaultrole'])
		{
			return $course['defaultrole'];
		} elseif ($roleid = $this->moodle_get_config('defaultcourseroleid')) {
			return $roleid;
		} else {
			return 5;
		}
	}
	
	function moodle_get_course_contextid($course_id)
	{
		global $moodle_course_context;
		
		if ($moodle_course_context[$course_id]) return $moodle_course_context[$course_id];
		if ($contextid = $this->query_one("SELECT id FROM [db]context WHERE contextlevel='50' AND instanceid='$course_id'"))
		{
			return $moodle_course_context[$course_id] = $contextid;
		} else {
			$this->query("INSERT INTO [db]context SET contextlevel='50', instanceid='$course_id'");
			if ($contextid = mysql_insert_id($this->db->conn))
				return $moodle_course_context[$course_id] = $contextid;
			else
				return $moodle_course_context[$course_id] = $this->query_one("SELECT id FROM [db]context WHERE contextlevel='50' AND instanceid='$course_id'");
		}
	}
	
	function moodle_assign_student_role($moodle_user_id, $course_id)
	{
		global $db;
		
		if (!$moodle_user_id || !$course_id) return;
		
		$moodle_course = $this->moodle_get_course($course_id);
		if ($moodle_course['enrolperiod'])
		{
			$timestart = time();
			$timeend = time() + $moodle_course['enrolperiod'];
		} else {
			$timestart = $timeend = 0;
		}
		$roleid = $this->moodle_get_course_roleid($course);
		$contextid = $this->moodle_get_course_contextid($course_id);

		$this->query("INSERT INTO [db]role_assignments SET
					roleid='$roleid',
					contextid='$contextid',
					userid='$moodle_user_id',
					hidden='0',
					timestart='$timestart',
					timeend='$timeend',
					timemodified='".time()."',
					modifierid='0',
					enrol='manual',
					sortorder='0'");
					
		$this->moodle_add_log($moodle_user_id, $course_id, 'course', 'enrol', "view.php?id=$course_id");
	}
	
	function moodle_unassign_student_role($moodle_user_id, $course_id)
	{
		if (!$moodle_user_id || !$course_id) return;
		$moodle_course = $this->moodle_get_course($course_id);
		$roleid = $this->moodle_get_course_roleid($course);
		$contextid = $this->moodle_get_course_contextid($course_id);
		$this->query("DELETE FROM [db]role_assignments WHERE roleid='$roleid' AND contextid='$contextid' AND userid='$moodle_user_id'");
	}
	
	function moodle_enrole($member, $moodle_user_id)
	{
		global $db;
		
		if (!$moodle_user_id) return;
		$max = $this->get_max($member['data']['status']);
		$moodle_courses = $this->moodle_get_courses();
		$moodle_user_courses = $this->moodle_get_user_courses($moodle_user_id);
		foreach ($max as $course_id)
		{
			if ($moodle_courses[$course_id] && !in_array($course_id, $moodle_user_courses))
				$this->moodle_assign_student_role($moodle_user_id, $course_id);
		}
	}
	
	function moodle_endecrypt($pwd, $data, $case)
	{
	    if ($case == 'de')
	        $data = urldecode($data);

	    $key[] = '';
	    $box[] = '';
	    $temp_swap = '';
	    $pwd_length = 0;

	    $pwd_length = strlen($pwd);

	    for ($i = 0; $i <= 255; $i++) {
	        $key[$i] = ord(substr($pwd, ($i % $pwd_length), 1));
	        $box[$i] = $i;
	    }
	    $x = 0;
	    for ($i = 0; $i <= 255; $i++) {
	        $x = ($x + $box[$i] + $key[$i]) % 256;
	        $temp_swap = $box[$i];
	        $box[$i] = $box[$x];
	        $box[$x] = $temp_swap;
	    }

	    $temp = '';
	    $k = '';
	    $cipherby = '';
	    $cipher = '';

	    $a = 0;
	    $j = 0;

	    for ($i = 0; $i < strlen($data); $i++) {
	        $a = ($a + 1) % 256;
	        $j = ($j + $box[$a]) % 256;
	        $temp = $box[$a];
	        $box[$a] = $box[$j];
	        $box[$j] = $temp;
	        $k = $box[(($box[$a] + $box[$j]) % 256)];
	        $cipherby = ord(substr($data, $i, 1)) ^ $k;
	        $cipher .= chr($cipherby);
	    }

	    if ($case == 'de') {
	        $cipher = urldecode(urlencode($cipher));
	    } else {
	        $cipher = urlencode($cipher);
	    }

	    return $cipher;
	}

	function moodle_rc4encrypt($data) {
	    $password = 'nfgjeingjk';
	    return $this->moodle_endecrypt($password, $data, '');
	}
	
	function moodle_rc4decrypt($data) {
	    $password = 'nfgjeingjk';
	    return $this->moodle_endecrypt($password, $data, 'de');
	}

	
	function moodle_get_user($login)
	{
		$res = $this->query("SELECT * FROM [db]user WHERE username = '$login'");
		return mysql_fetch_assoc($res);
	}

	function moodle_get_config($name)
	{
		global $moodle_config_data;
		
		// load some config
		if (!$moodle_config_data)
		{
			$default_config_names = array('sessioncookie','dbsessions','sessioncookiepath','sessiontimeout','defaultcourseroleid','notloggedinroleid','auth_plugins_enabled','mnet_localhost_id');
			$res = $this->query("SELECT name, value FROM [db]config WHERE name IN ('".implode("','",$default_config_names)."')");
			while ($config_data = mysql_fetch_assoc($res))
				$moodle_config_data[$config_data['name']] = $config_data['value'];
		}
		
		if (isset($moodle_config_data[$name]))
			return $moodle_config_data[$name];
		else
			return $moodle_config_data[$name] = $this->query_one("SELECT value FROM [db]config WHERE name = '$name'");
	}
	
	function moodle_random_string($length=15)
	{
	    $pool  = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
	    $pool .= 'abcdefghijklmnopqrstuvwxyz';
	    $pool .= '0123456789';
	    $poollen = strlen($pool);
	    mt_srand ((double) microtime() * 1000000);
	    $string = '';
	    for ($i = 0; $i < $length; $i++) {
	        $string .= substr($pool, (mt_rand()%($poollen)), 1);
	    }
	    return $string;
	}

	function moodle_cleanremoteaddr($addr)
	{
	    $originaladdr = $addr;
	    $matches = array();
	    if (!preg_match_all('/(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/',$addr,$matches,PREG_SET_ORDER))
	        return '';
	    $goodmatches = array();
	    $lanmatches = array();
	    foreach ($matches as $match) {
	        // check to make sure it's not an internal address.
	        // the following are reserved for private lans...
	        // 10.0.0.0 - 10.255.255.255
	        // 172.16.0.0 - 172.31.255.255
	        // 192.168.0.0 - 192.168.255.255
	        // 169.254.0.0 -169.254.255.255
	        $bits = explode('.',$match[0]);
	        if (count($bits) != 4)
	            continue;
	        if (($bits[0] == 10)
	            || ($bits[0] == 172 && $bits[1] >= 16 && $bits[1] <= 31)
	            || ($bits[0] == 192 && $bits[1] == 168)
	            || ($bits[0] == 169 && $bits[1] == 254))
			{
	            $lanmatches[] = $match[0];
	            continue;
	        }
	        $goodmatches[] = $match[0];
	    }
	    if (!count($goodmatches))
		{
	        if (!count($lanmatches))
	            return '';
	        else
	            return array_pop($lanmatches);
	    }
	    if (count($goodmatches) == 1)
	        return $goodmatches[0];
	    return array_pop($goodmatches);
	}
	
	function moodle_getremoteaddr()
	{
	    if (!empty($_SERVER['HTTP_CLIENT_IP'])) {
	        return $this->moodle_cleanremoteaddr($_SERVER['HTTP_CLIENT_IP']);
	    }
	    if (!empty($_SERVER['HTTP_X_FORWARDED_FOR'])) {
	        return $this->moodle_cleanremoteaddr($_SERVER['HTTP_X_FORWARDED_FOR']);
	    }
	    if (!empty($_SERVER['REMOTE_ADDR'])) {
	        return $this->moodle_cleanremoteaddr($_SERVER['REMOTE_ADDR']);
	    }
	    return '';
	}

	function moodle_fwrite($filename,$content)
	{
		if ($content == '')
			return false;
		if (!($fp = @fopen($filename, 'w')))
			 return false;
		if (@flock($fp, LOCK_EX))
		{
			if (@fwrite($fp, $content) === false)
				return false;
			@flock($fp, LOCK_UN);
		} else {
			if (@fwrite($fp, $content) === false)
				return false;
		}
		@fclose($fp);
	}
	
	function moodle_get_course($course_id)
	{
		global $moodle_courses;
		if ($moodle_courses[$course_id])
		{
			return $moodle_courses[$course_id];
		} else {
			$course = $this->query_first("SELECT * FROM [db]course WHERE id = '$course_id'");
			if ($course) $moodle_courses[$course_id] = $course;
			return $course;
		}
	}
	
	function moodle_get_courses()
	{
		global $moodle_courses;
		
		if ($moodle_courses)
		{
			return $moodle_courses;
		} else {
			$courses = array();
			$res =  $this->query("SELECT * FROM [db]course WHERE id <> 1");
			while ($course = mysql_fetch_assoc($res))
			{
				$courses[$course['id']] = $course;
			}
			if ($courses) $moodle_courses = $courses;
			return $courses;
		}
	}
	
	function moodle_get_settings($path='')
	{
		global $plugin_config, $config, $moodle_settings;

		if ($moodle_settings)
			return $moodle_settings;
			
		if ($path)
		{
			$moodle_path = $path;
		} else {
			if ($this->config['full_path'])
				$moodle_path = $this->config['full_path'];
			else
				$moodle_path = $plugin_config['protect']['moodle']['full_path'];
		}
			
		
		$settings = array('dbtype' => '', 'dbhost' => '', 'dbname' => '', 'dbuser' => '',
						'dbpass' => '', 'prefix' => '', 'wwwroot' => '', 'dataroot' => '');
		
		if (!$moodle_path)
		{
			return "Moodle plugin not configured. Please configure Moodle plugin at aMember CP -> Setup -> Moodle";
		}
		if (!($settings_file = @file($moodle_path."/config.php")) || count($settings_file) < 16)
			return "Moodle plugin error. Error reading config.php or bad config.php";
		
		$settings_loaded = 0;
		foreach ($settings_file as $line_number => $string)
		{
			foreach (array_keys($settings) as $varname)
			{
				if (($varstring = strstr($string, '->'.$varname)))
				{
					if (preg_match("/={1}[\t ]*['\"]{1}([^\"']*)['\"]{1};/",$varstring,$matches))
					{
						if ($varname != 'dbpass' && $varname != 'prefix' && $matches[1] == '')
						{
							return "Moodle plugin error. Error parsing config.php, or some variables missing";
						} else {
							$settings[$varname] = $matches[1]; // just get value string
							$settings_loaded++;						
						}
					}
				}
			}
		}
		if ($settings['dbtype'] == ''
			|| $settings['dbhost'] == ''
			|| $settings['dbname'] == ''
			|| $settings['dbuser'] == ''
			|| $settings['wwwroot'] == ''
			|| $settings['dataroot'] == '')
		{
			return "Moodle plugin error. Not all settings loaded, check config.php";
		} else {
			$this->config['full_path'] = $moodle_path;
			$moodle_settings = $settings;
			return $settings;
		}
	}

	function moodle_connect($settings)
	{
		if (!($error = $this->check_setup_moodle($settings)))
			$this->init_database();
		else
			return $error;
	}
	
	function validate_moodle_db($settings)
	{
	    global $db;
		
		if ($error = $this->moodle_connect($settings))
			return $error;
		
		if ($this->db)
		{
			@mysql_query("SELECT * FROM {$this->config['db']}user LIMIT 1", $this->db->conn);    
			if ((@mysql_errno($this->db->conn) == 1142) &&
				(preg_match("/SELECT command denied to user: '(.+?)@.+' for table '(.+?)'/", @mysql_error($this->db->conn), $regs))){
				$db_name = preg_replace('/\..+$/', '', $this->config['db']);
				return "Please go to webhosting control panel and allow access for user [$regs[1]] to database [$db_name]<br />" . @mysql_error($this->db->conn);
			}
			if (@mysql_errno($this->db->conn)) 
				return "Moodle error: " . @mysql_error($this->db->conn);
		} else {
			return $_SESSION['check_setup_moodle_error'];
		}
	}
	
	function check_moodle_settings()
	{
		global $db, $config;
		if ($this->config['full_path'])
		{
			if ($error = $this->check_setup_moodle())
				return $error;
		} else {
			return "Moodle plugin not configured. Please configure Moodle plugin at aMember CP -> Setup -> Moodle";
		}
	}
	
	function moodle_mkdir()
	{
		$settings = $this->moodle_get_settings();
		@mkdir($settings['dataroot']."/lang");
		@mkdir($settings['dataroot']."/lang/en_utf8_local");
	}
	
	function check_moodle_auth_amember($link)
	{
		global $db;
		$settings = $this->moodle_get_settings();
		
		$lang_file = $settings['dataroot']."/lang/en_utf8_local/auth.php";
		if (!(@is_dir(dirname($lang_file)))) $this->moodle_mkdir();			
		if (!(@is_file($lang_file)))
		{
			$this->moodle_fwrite($lang_file,"<?php\n\$string['auth_amembertitle']='aMember';\n\$string['auth_amemberdescription']='aMember Authentication Module';\n?>");
		}
		
		if ($link)
		{
			$settings = array('auth_amember_dbhost','auth_amember_dbname','auth_amember_dblogin','auth_amember_dbpass','auth_plugins_enabled');
			$res = @mysql_query($s = "SELECT * FROM {$this->config['db']}config WHERE name IN ('".implode("','",$settings)."')", $link);
			$count = @mysql_num_rows($res);
			if (!$count || $count == 1)
			{
				while ($config = mysql_fetch_assoc($res))
				{
					if ($config['name'] == 'auth_plugins_enabled')
					{
						$auth_plugins_enabled = explode(",",$config['value']);
					}
				}
				$values = "('auth_amember_dbhost', '{$db->config['host']}'),
							('auth_amember_dbname', '".$db->config['db'].".".$db->config['prefix']."'),
							('auth_amember_dblogin', '{$db->config['user']}'),
							('auth_amember_dbpass', '{$db->config['pass']}')";
				@mysql_query($s = "INSERT INTO {$this->config['db']}config (name, value) VALUES $values", $link);
			} else {
				while ($config = mysql_fetch_assoc($res))
				{
					$moodle_config[$config['name']] = $config['value'];
				}
				if ($moodle_config['auth_amember_dbhost'] != $db->config['host'] ||
					$moodle_config['auth_amember_dbname'] != $db->config['db'].".".$db->config['prefix']  ||
					$moodle_config['auth_amember_dblogin'] != $db->config['user'] ||
					$moodle_config['auth_amember_dbpass'] != $db->config['pass'])
				{
					$values = "('auth_amember_dbhost', '{$db->config['host']}'),
					('auth_amember_dbname', '".$db->config['db'].".".$db->config['prefix']."'),
					('auth_amember_dblogin', '{$db->config['user']}'),
					('auth_amember_dbpass', '{$db->config['pass']}')";
					@mysql_query($s = "REPLACE INTO {$this->config['db']}config (name, value) VALUES $values", $link);
				}
			}
		}
	}
	
	function check_setup_moodle($settings=array())
	{
		global $db, $config;
		$pn = substr($filename = basename(__FILE__),0,strpos($filename,"."));
		if ($pn == '') return "Cannot determine plugin name in file ".__FILE__." at line ".__LINE__;
		
		if (!$settings)
		{
			if (!is_array($settings = $this->moodle_get_settings()))
			{
				$_SESSION['check_setup_'.$pn.'_error'] = $settings;
				return $settings;
			}
		}
		
		if ($_SESSION['_admin_login'] && $_SESSION['amember_admin'])
			$in_admin = true;

		if ($in_admin)
		{
			if ($settings['dbhost'] && $settings['dbname'] && $settings['dbuser'])
			{
				if ($link = @mysql_connect($settings['dbhost'], $settings['dbuser'], $settings['dbpass'], true))
				{
					$this->config['host'] = $settings['dbhost'];
					$this->config['user'] = $settings['dbuser'];
					$this->config['pass'] = $settings['dbpass'];
					if (!$settings['dbname'])
					{
						if ($link && $link != $db->conn) @mysql_close($link);
						$this->config['db'] = '';
						$error = ucfirst($pn)." plugin error. Empty database name in Moodle config.php";
						$_SESSION['check_setup_'.$pn.'_error'] = $error;
						return $error;
					}
					if ($db_found = @mysql_select_db($settings['dbname'], $link))
					{
						$this->config['db'] = $settings['dbname'].".".$settings['prefix'];
						$this->check_moodle_auth_amember($link);
						if ($link && $link != $db->conn) @mysql_close($link);
					} else {
						$error = ucfirst($pn)." plugin error. Cannot select MySQL db: '".$settings['dbname']."' " . @mysql_error($link);
						if ($link && $link != $db->conn) @mysql_close($link);
						$_SESSION['check_setup_'.$pn.'_error'] = $error;
						return $error;
					}
				} else {
					$error = ucfirst($pn)." plugin error. Wrong MySQL username, password or hostname in Moodle config.php: " . @mysql_error($link);
					$_SESSION['check_setup_'.$pn.'_error'] = $error;
					$this->config['host'] = '';
					$this->config['user'] = '';
					$this->config['pass'] = '';
					return $error;
				}
			} else {	
				$error = ucfirst($pn)." plugin error. Empty Database configutation. Please configure '".$pn."' plugin at aMember CP -> Setup -> ".ucfirst($pn);
				if (!$_SESSION['check_setup_'.$pn.'_error']) $db->log_error($error);
				$_SESSION['check_setup_'.$pn.'_error'] = $error;
				return $error;
			}
		} elseif (!$settings['dbhost'] || !$settings['dbname'] || !$settings['dbuser']) {
			$error = ucfirst($pn)." plugin error. Empty Database configutation. Please configure '".$pn."' plugin at aMember CP -> Setup -> ".ucfirst($pn);
			if (!$_SESSION['check_setup_'.$pn.'_error']) $db->log_error($error);
			$_SESSION['check_setup_'.$pn.'_error'] = $error;
			return $error;		
		} else {
			$this->config['host'] = $settings['dbhost'];
			$this->config['user'] = $settings['dbuser'];
			$this->config['pass'] = $settings['dbpass'];
			$this->config['db'] = $settings['dbname'].".".$settings['prefix'];			
		}
	}
	
	function moodle_get_courses_list()
	{
		global $db;
		$res = $this->query("SELECT * FROM [db]course WHERE id <> 1 ");
		while ($course = mysql_fetch_assoc($res))
		{
			$courses[$course['id']] = $course['shortname'];
		}
		if ($courses)
			return array('' => '*** No access ***') + $courses;
		else
			return array('' => '');
	}
	
	function init()
    {
		$pn = $this->get_plugin_name();
		parent::init();
		add_product_field("{$pn}_access",
			'Moodle access', 'multi_select', "users ordered this product will<br>
				get the following courses in Moodle", '',
				array('options' => $this->moodle_get_courses_list()));
    }	
}

global $protect_moodle;
$protect_moodle = & instantiate_plugin("protect", "moodle");
if (!($error = $protect_moodle->check_moodle_settings()))
	$protect_moodle->init();
		
function check_setup_moodle()
{
	global $protect_moodle;
	if ($protect_moodle)
		return $protect_moodle->check_setup_moodle();
}

?>